<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no"
    />

    <title>AuRa - Überblick und Ausblick zum Automated Radio Projekt</title>

    <link rel="stylesheet" href="reveal.js/dist/reset.css" />
    <link rel="stylesheet" href="reveal.js/dist/reveal.css" />
    <link rel="stylesheet" href="reveal.js/dist/theme/black.css" id="theme" />

    <!-- Theme used for syntax highlighted code -->
    <link
      rel="stylesheet"
      href="plugin/highlight/zenburn.css"
      id="highlight-theme"
    />

    <!-- our local modifications -->
    <link rel="stylesheet" href="local.css" />
  </head>

  <body>
    <div class="reveal">
      <div class="slides">
        <!--
        Note on markdown page breaks:
        According to https://revealjs.com/markdown/ it should be possible to
        write all pages in one consecutive section/textarea segment, but no matter
        how I configured it, the page break does not work. Therefore I am using
        individual section/textarea segments.
        -->

        <section data-markdown>
          <textarea data-template>
            <div style="float: left;">
              <img data-src="imgs/aura-logo.png" width="150px" style="transform: rotate(-5deg); margin-bottom: 5em;">
            </div>

            ## Überblick und Ausblick zum <span class="hl">Au</span>tomated <span class="hl">Ra</span>dio Projekt

            @ [ZWCM2020](https://www.community-media.net/)

            jackie / Andrea Ida Malkah Klaura &lt;<a href="mailto:jackie@diebin.at">jackie@diebin.at</a>&gt;<br>
            David Trattnig &lt;<a href="mailto:david.trattnig@o94.at">david.trattnig@o94.at</a>&gt;

            <small>
              the internet, 7. November 2020<br><br>

              Diese Präsentation und ihr [Sourcecode](https://gitlab.servus.at/aura/aura/-/blob/main/presentations/zwcm2020)
              stehen unter einer [AGPLv3](https://gitlab.servus.at/aura/aura/-/blob/main/LICENSE)
              Lizenz. Wir verwenden dazu das Präsentations-Framework [reveal.js](https://revealjs.com),
              welches unter einer [MIT](https://github.com/hakimel/reveal.js/blob/main/LICENSE)
              Lizenz veröffentlicht ist.
            </small>
          </textarea>
        </section>

        <section data-markdown>
          <textarea data-template>
            # 90min roadmap

            - AuRa zum Radiomachen - <b class="hl">was kanns?</b>
            - AuRa als Softwareprojekt - <b class="hl">wie läufts?</b>
            - AuRa als Architektur - <b class="hl">wo läufts?</b>
            - F&A und visuelle Einblicke - <b class="hl">wie schauts aus?</b>
          </textarea>
        </section>

        <!-- AuRa zum Radiomachen - was kanns? -->
        <section>
          <section data-markdown>
            <textarea data-template>
              # AuRa zum Radiomachen
              ## <b class="hl">was kanns?</b>
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              <img data-src="imgs/dashboard-user-shows.png" width="70%">
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              <img data-src="imgs/dashboard-user-files.png" width="70%">
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              <img data-src="imgs/dashboard-admin-shows.png" width="70%">
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              <img data-src="imgs/dashboard-admin-create-show.png" width="70%">
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              <img data-src="imgs/dashboard-admin-calendar.png" width="70%">
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## AuRa users
              - <!-- .element: class="fragment" data-fragment-index="1" --> <b class="hl">Radiomacher*innen</b>
                - Verwalten ihre eigenen Sendungen:
                  - Hochladen von vorproduzierten Sendungen
                  - Einstellen von Playlisten
                  - Beschreiben einzelner Sendungstermine
              - <!-- .element: class="fragment" data-fragment-index="2" --> <b class="hl">Programmkoordinator*innen</b>
                - Verwalten Sendereihen:
                  - Erstellen neuer Sendereihen
                  - Erstellen neuer Senderhythmen und Sendungstermine
                  - Erstellen und Zuordnen neuer Radiomacher*innen-Accounts
                  - Bearbeiten von Metadaten einer Sendereihe
                  - Deaktivieren von alten Sendereihen
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## AuRa users (indirect)
              - <!-- .element: class="fragment" data-fragment-index="1" --> <b class="hl">Leute im Studio</b>
                - Schauen auf die Studio-Uhr
              - <!-- .element: class="fragment" data-fragment-index="2" --> <b class="hl">Website-Besucher*innen</b> und <b class="hl">Hörer*innen</b>
                - Wollen wissen wann was läuft
                - Wollen wissen wann was lief
                - Wollen Infos zu einzelnen Sendereihen
                - Wollen Livestream oder archivierte Sendungen hören
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## Interface requirements
              - <!-- .element: class="fragment" data-fragment-index="1" --> am besten alles von einem Ort aus machen
              - <!-- .element: class="fragment" data-fragment-index="2" --> aber egal von welchem Ort
              - <!-- .element: class="fragment" data-fragment-index="3" --> mobile ready
              - <!-- .element: class="fragment" data-fragment-index="4" --> an eigene Bedürfnisse anpassbar
              - <!-- .element: class="fragment" data-fragment-index="5" --> gleiches Interface für RM und PK
                - aber mit mehr capabilities für PK
              - <!-- .element: class="fragment" data-fragment-index="6" --> auch externe Workflows (z.B. CBA) integrieren
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## Was AuRa noch können soll
              - Cut & Glue von archivierten Sendungen
              - Jingles verwalten (fürs Radio und für Sendereihen)
              - Dynamische Playlisten (z.B. Musikpools)
              - Automatisierte Sendungswiederholungen
              - Automatisierte Sendungsübernahmen
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## Was AuRa (noch?) nicht macht
              - Live studio mixing
              - Live studio info -> trackservice
              - Kaffee kochen
            </textarea>
          </section>
        </section>

        <!--  AuRa als Softwareprojekt - wie läufts? -->
        <section>
          <section data-markdown>
            <textarea data-template>
              # AuRa als Softwareprojekt
              ## <b class="hl">wie läufts?</b>
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## “free” as in “free speech”,<br>not as in “free beer”
              <small>(source: <a href="https://www.gnu.org/philosophy/free-sw.html">https://www.gnu.org/philosophy/free-sw.html</a>)</small>
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## Ausgangsbasis
              ### bei ORANGE 94.0 (Wien)
              - <!-- .element: class="fragment" data-fragment-index="1" --> ~ 450 Radiomacher*innen und 198 Sendereihen
              - <!-- .element: class="fragment" data-fragment-index="2" --> Ein veraltetes unmaintainable Playoutsystem (YARM)
              - <!-- .element: class="fragment" data-fragment-index="3" --> Ein Programmverwaltungssystem das auf OpenACS basiert (in TCL geschrieben) und auf einem AolServer4 aufsetzt
              - <!-- .element: class="fragment" data-fragment-index="4" --> Eine veraltete Website mit unzähligem unmaintained Script-Patchwork
              - <!-- .element: class="fragment" data-fragment-index="5" --> Ganz viele Bash- & PHP-Skripte dazwischen und rundherum
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## Ausgangsbasis
              ### bei den Projektpartner\*innen
              - <!-- .element: class="fragment" data-fragment-index="1" --> FRO (Linz): Playout via YARM, kriselt schon, ~ 280 RM
              - <!-- .element: class="fragment" data-fragment-index="2" --> FRF (Freistadt): früher YARM, inzwischen Airtime, > 100 RM, 70 Sendereihen
              - <!-- .element: class="fragment" data-fragment-index="3" --> Helsinki (Graz): Rivendell, selbst entwickelte PV (aus der AURA Steering wurde), > 220 RM
              - <!-- .element: class="fragment" data-fragment-index="4" --> Radiofabrik (Salzburg): Playout via YARM, läuft noch (!) ganz ok, > 350 RM, 204 Sendereihen, ~8.5 Std. Programm-Neuschöpfung / Tag

              <small>Stand, Nov. 2020, statistische Daten von den Websites der Radios übernommen</small>
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## Beispiel ORANGE 94.0
              <img data-src="imgs/currentsetup.jpg" width="85%">
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## "Allein machen sie dich ein"
              ### why <b class="hl">Y</b>et <b class="hl">A</b>nother <b class="hl">R</b>adio <b class="hl">M</b>anager?
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## Y.A.R.M.
              - <!-- .element: class="fragment" data-fragment-index="1" --> Java-basiertes Playout-System
              - <!-- .element: class="fragment" data-fragment-index="2" --> 2004 bei der Radiofabrik Salzburg entwickelt
              - <!-- .element: class="fragment" data-fragment-index="3" --> Von mehreren anderen Freien Radios übernommen
              - <!-- .element: class="fragment" data-fragment-index="4" --> Inzwischen veraltet und unmaintained
              - <!-- .element: class="fragment" data-fragment-index="5" --> Entwicklung blieb an einer Person hängen und vollständiges Open Sourcing hat nie geklappt

              <small>[Y.A.R.M. im Webarchiv der Radiofabrik](https://radiofabrik.at/organisation/projekte/abgeschlossene-projekte/y-a-r-m-2004-2014/)</small>
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## Initiative zu AuRa
              - <!-- .element: class="fragment" data-fragment-index="1" --> Radiofabrik, Radio FRO, Freies Radio Freistadt, ORANGE 94.0 hingen (damals) alle noch am YARM
              - <!-- .element: class="fragment" data-fragment-index="2" --> Dringender Bedarf für etwas Neues, gut Handhabbares
              - <!-- .element: class="fragment" data-fragment-index="3" --> Erhebung von über 50 Anwendungen (FLOSS und kommerziell) ergibt
                - Keine bestehende Software erfüllt alle unsere Anforderungen ausreichend
              - <!-- .element: class="fragment" data-fragment-index="4" --> Radio Helsinki (Graz) hat bereits eine eigene brauchbare Programmverwaltung auf Django-Basis öffentlich entwickelt (https://git.helsinki.at/)
              - <!-- .element: class="fragment" data-fragment-index="5" --> Michael Liebler (Radio Z, Nürnberg) hat ein Playoutsystem mit Python öffentlich entwickelt (https://gitlab.janguo.de/groups/comba)
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## <b class="hl">Arrr!</b> Auf zu neuen Ufern! <b class="hl">(2017)</b>
              - <!-- .element: class="fragment" data-fragment-index="1" --> Wir <span class="hl">poolen unsere Ressourcen</span>:
                - FRO, FRF, ORANGE und Radiofabrik sowie Helsinki stellen Kohle bzw. Arbeitsleistungen zur Verfügung
                - 4 Core Developers (2x FRO, 1x Helsinki, 1x ORANGE)
                - insgesamt ~ 1 bis 1.5 Vollzeitäquivalente an Entwickler\*innenzeit
              - <!-- .element: class="fragment" data-fragment-index="2" --> Wir <span class="hl">setzen auf bereits bestehende Projekte auf</span>:
                - <!-- .element: class="fragment" data-fragment-index="3" --> Helsinki Programmverwaltung in Django (Python)
                - <!-- .element: class="fragment" data-fragment-index="4" --> Python-basiertes Playout auf COMBA-Basis
                - <!-- .element: class="fragment" data-fragment-index="5" --> Einarbeitung des gemeinsamen Pflichtenhefts <span class="hl">mehrerer Radios</span>
                - <!-- .element: class="fragment" data-fragment-index="6" --> <span class="hl">Extensive Planung</span> von Architektur &amp; APIs <b>VOR der Implementierung</b>
                - <!-- .element: class="fragment" data-fragment-index="7" --> Wir entwickeln <span class="hl">von Anfang an öffentlich als freie Software</span>
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## Aktueller Status
              ### Komponenten
              - <!-- .element: class="fragment" data-fragment-index="1" --> <b class="hl">steering</b> (= Programmveraltung): aus der Helsinki PV weiterentwickelt
              - <!-- .element: class="fragment" data-fragment-index="2" --> <b class="hl">engine</b> (= Playout): ursprünglich COMBA-based, im Grunde neu geschrieben und reduziert
              - <!-- .element: class="fragment" data-fragment-index="3" --> <b class="hl">tank</b> (= Importer): auf Helsinki-Komponente basierend neu für AuRa
              - <!-- .element: class="fragment" data-fragment-index="4" --> <b class="hl">dashboard</b> (= UI): Neuentwicklung spezifisch für AuRa (siehe vorige Screenshots)
              - <!-- .element: class="fragment" data-fragment-index="5" --> <b class="hl">battery</b> (= Aufnameverwaltung): in Planung

              <img data-src="imgs/meta-repo-components.png" width="70%">
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## Aktueller Status
              ### Team
              - 5 Core Developers (2x ORANGE, 2x Helsinki, 1x Radiofabrik)
              - 1 Projektleitung
              - 1 UI Tester und GFX Contributor

              <img data-src="imgs/credits.png">
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## Aktueller Status
              ### Work packages
              - 122 open issues
              - 110 closed issues
              - 20 epic issues
              - for AuRa 1.0:
                - 49 open issues (7 epics)
              - for AuRa 1.1:
                - 30 open issues (6 epics)

              <img data-src="imgs/issues.png">
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## Aktuelle Herausforderungen
              - <!-- .element: class="fragment" data-fragment-index="1" --> Keine klaren Maintainer-Strukturen & -Kapazitäten
              - <!-- .element: class="fragment" data-fragment-index="2" --> Requirements werden langsam unübersichtlich, geraten in Vergessenheit oder tauchen neu auf
              - <!-- .element: class="fragment" data-fragment-index="3" --> 20 Wochenstunden pro Komponente mit nachhaltiger Beteiligung wären eigentlich ein Minimum
                - zur Zeit haben wir 2 davon (die beiden neuesten Core Devs)
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## Aktueller Zeitplan
              - Jänner 2021: Vollständige API-Spezifikationen
              - Februar 2021: Start der "Playout" Testphase (AuRa 1.0)
              - Juli 2021: Start der "High Availability" Testphase (AuRa 1.1)

              <img data-src="imgs/projectplanning.png">
            </textarea>
          </section>
        </section>

        <!--  AuRa als Architektur - wo läufts? -->
        <section>
          <section data-markdown>
            <textarea data-template>
              # AuRa als Architektur
              ## <b class="hl">wo läufts?</b>
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## <b class="hl">au</b>to<b class="hl">ra</b>dio
              - https://gitlab.servus.at/autoradio
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## Technisch-organisatorische Anforderungen:
              - <!-- .element: class="fragment" data-fragment-index="1" --> Modularer Aufbau, bei dem einzelne Komponenten ausgetauscht werden können
              - <!-- .element: class="fragment" data-fragment-index="2" --> Transparente und gut beschriebene Schnittstellen, die mit einer REST API implementiert werden
              - <!-- .element: class="fragment" data-fragment-index="3" --> Aufbau auf bestehenden Teillösungen die in einzelnen Radios bereits erprobt sind
              - <!-- .element: class="fragment" data-fragment-index="4" --> Verwendung etablierter Entwicklungsframeworks
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## AuRa Datenmodell
              <img data-src="imgs/aura-data-model-simple.png">
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## AuRa Komponenten
              - <!-- .element: class="fragment" data-fragment-index="1" --><b class="hl">dashboard</b> (Javascript, Vue.js)
              - <!-- .element: class="fragment" data-fragment-index="2" --><b class="hl">steering</b> (Python, Django)
              - <!-- .element: class="fragment" data-fragment-index="3" --><b class="hl">engine</b> (Python & Liquidsoap)
              - <!-- .element: class="fragment" data-fragment-index="4" --><b class="hl">tank</b> (Go)
              - <!-- .element: class="fragment" data-fragment-index="5" --><b class="hl">battery</b> (Python)
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## Ursprüngliches Architekturmodell
              <img data-src="imgs/components.png">
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## Aktuelles Architekturmodell
              - möglichst simpel auf zwei Maschinen umsetzbar (theoretisch auch auf einer)
              - oder als redundante HA Variante
              - [aura-network-diagram-0.6.pdf](imgs/aura-network-diagram-0.6.pdf)
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              <img data-src="imgs/aura-network-single.png">
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              <img data-src="imgs/aura-network-redundant.png">
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## Setup
              - <!-- .element: class="fragment" data-fragment-index="1" --> zur Zeit noch nicht ganz trivial und ohne Linux admin skills nicht unbedingt zu empfehlen
              - <!-- .element: class="fragment" data-fragment-index="2" --> einiges ist schon containerized
              - <!-- .element: class="fragment" data-fragment-index="3" --> Ziel ist ein fully/mostly containerized setup (mit Docker)
              - <!-- .element: class="fragment" data-fragment-index="4" --> Setup procedure sollte im Idealfall reduzierbar sein auf:
                - repositories pullen
                - globale Umgebungsvariablen setzen
                - per Skript (oder direkt docker-compose) die Services starten
            </textarea>
          </section>

          <section data-markdown>
            <textarea data-template>
              ## Contributions
              - <!-- .element: class="fragment" data-fragment-index="1" --> für größere code contributions sollten wir vorher maintainers haben
              - <!-- .element: class="fragment" data-fragment-index="2" --> über einfachere bug fixes freuen wir uns
              - <!-- .element: class="fragment" data-fragment-index="3" --> eigene GitLab Instanz
                - ist in dem Fall eher ein Hindernis
                - über Accounts lässt sich aber reden
              - <!-- .element: class="fragment" data-fragment-index="4" --> am einfachsten können wir mit Doku contrib umgehen
                - ein gemeinsamer Standard/Format wär aber gut
              - <!-- .element: class="fragment" data-fragment-index="5" --> Lokalisierungen können auch bald gemacht werden und lassen sich gut auslagern
            </textarea>
          </section>
        </section>

        <section data-markdown>
          <textarea data-template>
            # Infos, Ressourcen und Kanäle
            - <!-- .element: class="fragment" data-fragment-index="1" --> GitLab: <a href="https://gitlab.servus.at/aura/">https://gitlab.servus.at/aura/</a>
              - v.a. das meta Repo mit Infos zum ersten Einstieg und den docs
              - und auch dieser Präsentation
            - <!-- .element: class="fragment" data-fragment-index="2" --> AuRa users mailinglist: <a href="https://mailman.o94.at/mailman/admin/aura-users">https://mailman.o94.at/mailman/admin/aura-users</a>
            - <!-- .element: class="fragment" data-fragment-index="3" --> AuRa Test Instanz: <a href="https://aura-test.o94.at/">https://aura-test.o94.at/</a> (write us for accounts)
            - <!-- .element: class="fragment" data-fragment-index="4" --> API Definitionen: <a href="https://gitlab.servus.at/aura/aura/-/blob/main/docs/development/api-definition.md">https://gitlab.servus.at/aura/aura/-/blob/main/docs/development/api-definition.md</a>
            - <!-- .element: class="fragment" data-fragment-index="4" --> Engine API spec: <a href="https://app.swaggerhub.com/apis/AURA-Engine/engine-api">https://app.swaggerhub.com/apis/AURA-Engine/engine-api</a>
            - <!-- .element: class="fragment" data-fragment-index="5" --> Mattermost (bislang nur intern)
          </textarea>
        </section>

        <section data-markdown>
          <textarea data-template>
            # <b class="hl">F</b> & <b class="hl">A</b>

            - Welche Fragen habt ihr?
            - Was wollt ihr sehen?
          </textarea>
        </section>

        <section data-markdown>
          <textarea data-template>
            <div style="float: left;">
              <img data-src="imgs/aura-logo.png" width="150px" style="transform: rotate(-5deg); margin-bottom: 5em;">
            </div>

            ## Überblick und Ausblick zum <span class="hl">Au</span>tomated <span class="hl">Ra</span>dio Projekt

            @ [ZWCM2020](https://www.community-media.net/)

            jackie / Andrea Ida Malkah Klaura &lt;<a href="mailto:jackie@diebin.at">jackie@diebin.at</a>&gt;<br>
            David Trattnig &lt;<a href="mailto:david.trattnig@o94.at">david.trattnig@o94.at</a>&gt;

            <small>
              the internet, 7. November 2020<br><br>

              Diese Präsentation und ihr [Sourcecode](https://gitlab.servus.at/aura/aura/-/blob/main/presentations/zwcm2020)
              stehen unter einer [AGPLv3](https://gitlab.servus.at/aura/aura/-/blob/main/LICENSE)
              Lizenz. Wir verwenden dazu das Präsentations-Framework [reveal.js](https://revealjs.com),
              welches unter einer [MIT](https://github.com/hakimel/reveal.js/blob/main/LICENSE)
              Lizenz veröffentlicht ist.
            </small>
          </textarea>
        </section>
      </div>
    </div>

    <script src="reveal.js/dist/reveal.js"></script>
    <script src="reveal.js/plugin/notes/notes.js"></script>
    <script src="reveal.js/plugin/markdown/markdown.js"></script>
    <script src="reveal.js/plugin/highlight/highlight.js"></script>
    <script src="reveal.js/plugin/zoom/zoom.js"></script>
    <script>
      // More info about initialization & config:
      // - https://revealjs.com/initialization/
      // - https://revealjs.com/config/
      Reveal.initialize({
        hash: true,

        // Learn about plugins: https://revealjs.com/plugins/
        plugins: [RevealMarkdown, RevealHighlight, RevealNotes, RevealZoom],
      })
    </script>
  </body>
</html>
